//
// Returns false if array is full...
//

public class ArrayMemoDatabase implements MemoDatabase
{
  private MemoAssociation[] pair;
  private int counter;
  
  public ArrayMemoDatabase()
  {
    pair = new MemoAssociation[10];
    counter = 0;
  }
   
  public boolean insert( MemoAssociation m )
  {
    if ( counter == pair.length )
      return false;
    
    if ( containsKey(m.key()) )
      return false;
    
    pair[counter] = m;
    counter++;
    return true;
  }
   
  public String find( String key )
  {
    for (int i = 0; i < counter; i++)
      if (key.equals( pair[i].key() ))
         return pair[i].value();
    return null;
  }
   
  public boolean remove( String key )
  {
    for (int i = 0; i < counter; i++)
      if (key.equals( pair[i].key() ))
      {
         pair[i] = pair[counter-1];
         counter--;
         return true;
      }
    return false;
  }
   
  public boolean containsKey( String key )
  {
    for (int i = 0; i < counter; i++)
      if (key.equals( pair[i].key() ))
         return true;
    return false;
  }
}
